/* filenameEntry.h

   Copyright (C) 1999 by David Rose.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

   To contact the original author of this program, write to:
           David Rose
           224 W. Dryden St Apt. 418
	   Glendale, CA 91202
	   USA

	   drose@lafn.org
   */

#ifndef FILENAMEENTRY_H
#define FILENAMEENTRY_H

#include <gtk--.h>

class FilenameEntry : public Gtk_HBox {
public:
  FilenameEntry();
  ~FilenameEntry();

  void set_filename(const string &filename);
  string get_filename();

  void popup_dialog();
  void delete_dialog();

  Signal0 activate;

private:
  void browse_button_clicked();
  void entry_activated();
  gint entry_keypress(GdkEventKey *p1); 
  void dialog_accepted();
  void dialog_deleted();

  void layout_window();

private:
  Gtk_FileSelection *_dialog;

  Gtk_Entry _entry;
  Gtk_Button _browse_button;
};

#endif
