/* shellCommand.h

   Copyright (C) 1999 by David Rose.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

   To contact the original author of this program, write to:
           David Rose
           224 W. Dryden St Apt. 418
	   Glendale, CA 91202
	   USA

	   drose@lafn.org
   */

#ifndef SHELLCOMMAND_H
#define SHELLCOMMAND_H

// This class executes an arbitrary shell command in a subprocess, and
// provides hooks to notify us when it's completed.

#include <gtk--.h>
#include <sys/types.h>

class ShellCommand : public Gtk_Signal_Base {
public:
  ShellCommand();
  ~ShellCommand();

  bool run(const string &command);
  void kill();
  bool is_running();

  Signal0 success;
  Signal0 failure;

private:
  void child_pid_done(pid_t pid, bool normal_exit, int exit_status);

  pid_t _pid;
};

#endif


